# RSA chiffrement et déchiffrement
# sv - 23.01.24

# x*a + y*b = pgcd(a, b)
def euclide_etendu(a, b):
    xa,ya,xb,yb = 1,0,0,1
    while b != 0:
        q = a//b
        a,xa,ya,b,xb,yb = b,xb,yb,a-q*b,xa-q*xb,ya-q*yb
    return a, xa, ya

# en passant : le pgdc
def pgdc(a, b):
    return euclide_etendu(a,b)[0]

# on peut utiliser pow
def expoMod(a, p, n):
    return pow(a, p, n)

# d est l'inverse de e modulo phi(n)
def inverse(a, b):
    if pgdc(a, b) != 1:
        return -1
    else:
        return euclide_etendu(a, b)[1] % b

# chiffrer avec RSA. Clé publique (n, e). message < n
def Chiffrement(n, e, message):
    return pow(message, e, n)

# déchiffrer avec RSA. Clé privé (n, d). chiffre < n
def Dechiffrement(p, q, e, chiffre):
    n = p*q
    phi = (p-1)*(q-1)
    d = inverse(e, phi)
    return pow(chiffre, d, n)






